﻿
--mielott elkezdjük, javítjuk az sztk adatmodellt, hogy több diagnózis is 
--mehessen egy esethez
drop table  eset_diagn
delete eset_diagn
create table eset_diagn (eset_id int not null,
diagn_id varchar(50) not null,
diagn_tipus_kod varchar(50) not null) --most a külso kulcsokkal nem foglalkozunk
go
alter table eset_diagn add constraint h33 primary key (diagn_id, eset_id, diagn_tipus_kod)
go
--a tényleges zárójelentés feldolgozása

--START

--beolvassuk fájlból egy változóba
set xact_abort on
set nocount on
begin tran
declare @zarojelentes_szoveg xml
select @zarojelentes_szoveg = tabla.uzenet from openrowset(bulk 'C:\temp\EHR_extract_pelda_ns_nelkul.xml', single_blob) as tabla (uzenet)
declare @knev varchar(100), @vnev varchar(100), @birth_time as date
select @vnev=t.namepart.value('.[1]', 'varchar(50)')  --az [1] értelme: lehetne több namepart node is a listában
from @zarojelentes_szoveg.nodes('/EHR_EXTRACT/demographic_extract/subject_of_care_person_identification/name/namePart[@namePartType="FAM"]') as t(namepart)
select @knev=t.namepart.value('.[1]', 'varchar(50)')
from @zarojelentes_szoveg.nodes('/EHR_EXTRACT/demographic_extract/subject_of_care_person_identification/name/namePart[@namePartType="GIV"]') as t(namepart)
select @vnev+' '+@knev as hogy_hivják
select @birth_time=t.part.value('.[1]', 'date')
from @zarojelentes_szoveg.nodes('/EHR_EXTRACT/demographic_extract/subject_of_care_person_identification/birthTime') as t(part)
print @birth_time
if not exists (select * from beteg where beteg_nev=@vnev+' '+@knev and szul_datum=@birth_time) begin
	print 'Nem találjuk a beteget'
	rollback tran
end else begin
	declare @beteg_id int
	select @beteg_id=beteg_id from beteg where beteg_nev=@vnev+' '+@knev
	print 'megvan a beteg: ' +@vnev+' '+@knev+ ' (id: '+ cast(@beteg_id as varchar(10))+'), született: ' + cast(@birth_time as varchar(50))
	--anyja neve?
	declare @anyja_neve nvarchar(100)
	select @vnev=t.namepart.value('.[1]', 'varchar(50)')  
	from @zarojelentes_szoveg.nodes('/EHR_EXTRACT/demographic_extract/subject_of_care_person_identification/mothersName/namePart[@namePartType="FAM"]') as t(namepart)
	select @knev=t.namepart.value('.[1]', 'varchar(50)')
	from @zarojelentes_szoveg.nodes('/EHR_EXTRACT/demographic_extract/subject_of_care_person_identification/mothersName/namePart[@namePartType="GIV"]') as t(namepart)
	set @anyja_neve=@vnev+' '+@knev
	print 'anyja neve: '+@anyja_neve
	update beteg set anyja_neve = @anyja_neve where beteg_id=@beteg_id
	--további adatok lekérdezése
	declare @zarojelentes nvarchar(max), @anamnezis nvarchar(max), @statusz nvarchar(max)
	select @statusz=t.part.value('.[1]', 'nvarchar(max)')
	from @zarojelentes_szoveg.nodes('/EHR_EXTRACT/all_compositions/composition/content/entry[@name="DL_STATUS"]/items/element[@name="DL_STATUS"]/string') as t(part)
	select @anamnezis=t.part.value('.[1]', 'nvarchar(max)')
	from @zarojelentes_szoveg.nodes('/EHR_EXTRACT/all_compositions/composition/content/entry[@name="DL_ANAMNESIS"]/items/element[@name="DL_ANAMNESIS"]/string') as t(part)
	select @zarojelentes=t.part.value('.[1]', 'nvarchar(max)')
	from @zarojelentes_szoveg.nodes('/EHR_EXTRACT/all_compositions/composition/content/entry[@name="DL_EPICRISIS"]/items/element[@name="DL_EPICRISIS"]/string') as t(part)
	print @statusz print @zarojelentes print @anamnezis
	--új eset létrehozása
	declare @eset_id int
	insert eset (beteg_id, zarojelentes, anamnezis, statusz, orvos_id) values (@beteg_id, @zarojelentes, @anamnezis, @statusz, 1) --igen szép lenne az orvost is átvenni!
	set @eset_id=@@IDENTITY
	--diagnózisok
--	select @zarojelentes=t.part.value('.[1]', 'nvarchar(max)')
	insert eset_diagn (eset_id, diagn_id, diagn_tipus_kod)
	select @eset_id, t.part.value('.[1]', 'nvarchar(50)'), 'általános'	--a diagn_típust a SYN_ICDTYPE elemből kellene átvenni...
	from @zarojelentes_szoveg.nodes('/EHR_EXTRACT/all_compositions/composition/content/section[@name="DL_DIAGNOSISES"]/members/entry[@name="SYN_BNO"]/items/cluster/parts/element[@name="SYN_ICDCODE"]/string') as t(part)			
	print 'eset sikeresen átvéve.'
	commit tran
end
go

--VÉGE
select * from beteg
update beteg SET anyja_neve='ISMERETLEN' where beteg_id=3
select * from eset where beteg_id=3
select * from eset_diagn



